## metview 5.7.5

=== CMakeLists.txt ===
cmake_minimum_required( VERSION 3.6.0 FATAL_ERROR )

include( ${INCLUDE_CONFIG}-local-config.cmake OPTIONAL )

set( CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake;${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake;${CMAKE_MODULE_PATH}" )

include( ecbuild_bundle )

project( MetviewMiniBundle C CXX Fortran )
set(CPACK_PACKAGE_NAME Metview)  # so that the source tarball will have the name 'Metview'


# list all the packages we incorporate into the bundle
set(MV_BUNDLE_PACKAGES METVIEW MARS_CLIENT MIR ATLAS ECKIT)

if(METVIEW_SITE STREQUAL ecmwf )
    list(APPEND MV_BUNDLE_PACKAGES FDB)
    list(APPEND MV_BUNDLE_PACKAGES ECMF_CONFIGS)
endif()

# create a variabe for each package we bundle
foreach (bunpack ${MV_BUNDLE_PACKAGES})
    set(MV_BUNDLE_CONTAINS_${bunpack} 1)
endforeach()


# -------------------------------------------------------------------------------------
# settings which are required across the packages to get a working Metview installation

#general
set(ENABLE_ODB           OFF CACHE BOOL "ODB support")
set(ENABLE_EXPERIMENTAL  OFF CACHE BOOL "Experimental features")

#mars
set(ECMWF             OFF CACHE BOOL "build the client as for ECMWF")
set(CONFIG_FDB        OFF CACHE BOOL "database configuration to access FDB")
set(ENABLE_UDP_STATS  OFF CACHE BOOL  "")
# -------------------------------------------------------------------------------------

macro(my_bundle_pkg)
    ecbuild_bundle( ${ARGV} )
endmacro()

ecbuild_bundle_initialize()

    ecbuild_add_option( FEATURE EXPOSE_SUBPACKAGES
                        DEFAULT OFF
                        DESCRIPTION "Allow separate use of the sub-packages in the bundle")



    # if the installer does not want to expose the sub-packages then we need to:
    # a) change $PREFIX so that everything is installed into a sub-directory
    # b) change the location of the Metview startup script so it's installed
    #    where intended (Metview takes care of this)

    if (NOT ENABLE_EXPOSE_SUBPACKAGES)
        set(ORIGINAL_CMAKE_INSTALL_PREFIX ${CMAKE_INSTALL_PREFIX})
        set(CMAKE_INSTALL_PREFIX "${CMAKE_INSTALL_PREFIX}/lib/metview-bundle")
    endif()

    if(MV_BUNDLE_CONTAINS_ECMWF_CONFIGS )
        ecbuild_bundle( PROJECT metview-ecmwf-configs  STASH "metv/metview-ecmwf-configs"  TAG  master  UPDATE )
    endif()


    if(MV_BUNDLE_CONTAINS_FDB)
        set( FDB_CONF_FILE /usr/local/apps/fdb/etc/Config )
        list(APPEND MV_BUNDLE_PACKAGES FDB)
        ecbuild_bundle( PROJECT fdb                STASH "mars/fdb_vintage"            TAG     4.10.0   UPDATE )
    else()
        set(FDB_DIR "/dummy/path/for/bundle")
    endif()

    my_bundle_pkg( PROJECT eckit        STASH "ecsdk/eckit"       TAG  1.4.4 )
    my_bundle_pkg( PROJECT atlas        STASH "atlas/atlas"       TAG  0.19.0 )
    my_bundle_pkg( PROJECT mir          STASH "mir/mir"           TAG  1.4.0 )
    my_bundle_pkg( PROJECT mars-client  STASH "mars/mars-client"  TAG  6.27.6 )
    my_bundle_pkg( PROJECT metview      STASH "metv/metview"      TAG  5.7.5 )

    ecbuild_dont_pack(FILES configure.sh;ecmwf;make-tarball.sh;test-tarball.sh;configure.clang.sh;bamboo)

ecbuild_bundle_finalize()


ecbuild_info("ENABLE_EXPOSE_SUBPACKAGES is ${ENABLE_EXPOSE_SUBPACKAGES}:")
if (ENABLE_EXPOSE_SUBPACKAGES)
    ecbuild_info("All packages in the bundle will be installed at the same level into:")
    ecbuild_info("  ${CMAKE_INSTALL_PREFIX}")
else()
    ecbuild_info("All packages in the bundle will be installed into a sub-directory:")
    ecbuild_info("  ${CMAKE_INSTALL_PREFIX}")
    ecbuild_info ("The Metview startup script will be installed into:")
    ecbuild_info("  ${ORIGINAL_CMAKE_INSTALL_PREFIX}/bin")
endif()

=== eckit/CMakeLists.txt ===
cmake_minimum_required( VERSION 3.1 FATAL_ERROR )

project( eckit CXX )

set( CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake")

include( ecbuild_system NO_POLICY_SCOPE )

ecbuild_requires_macro_version( 2.9 )

set( PERSISTENT_NAMESPACE "eckit" CACHE INTERNAL "" ) # needed for generating .b files for persistent support

ecbuild_declare_project()

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

### dependencies and options

ecbuild_add_option( FEATURE EXPERIMENTAL
                    DEFAULT OFF
                    DESCRIPTION "Experimental features that havent graduated to production ready code" )

ecbuild_add_option( FEATURE SANDBOX
                    DEFAULT OFF
                    DESCRIPTION "Experimental features that havent graduated to production ready code" )

### thread library ( preferably pthreads ) --- Must be called before FindCUDA!

if( ${CMAKE_VERSION} VERSION_LESS 3.14 )
    # Following variable is unused for CMake > 3.14
    set( CMAKE_THREAD_PREFER_PTHREAD 1 )
endif()

if( NOT DEFINED THREADS_PREFER_PTHREAD_FLAG )
  set( THREADS_PREFER_PTHREAD_FLAG 1 )
endif()
### Set THREADS_HAVE_PTHREAD_ARG variable to false so that it can be recomputed based on
### THREADS_PREFER_PTHREAD_FLAG, in case other project had it on a different setting.
### This is certainly a CMake bug ( see ECKIT-426 )
set( THREADS_HAVE_PTHREAD_ARG FALSE )
find_package( Threads REQUIRED )
set( THREADS_LIBRARIES ${CMAKE_THREAD_LIBS_INIT} )

### eckit::mpi

ecbuild_add_option( FEATURE MPI
                    DEFAULT ON
                    DESCRIPTION "Use system MPI libraries"
                    REQUIRED_PACKAGES "MPI COMPONENTS C" )

### eckit::cmd

ecbuild_add_option( FEATURE ECKIT_CMD
                    DEFAULT ON
                    DESCRIPTION "Utilities for administration tools"
                    REQUIRED_PACKAGES "LEXYACC" "Curses" )

### eckit::sql

ecbuild_add_option( FEATURE ECKIT_SQL
                    DEFAULT ON
                    DESCRIPTION "An SQL engine"
                    REQUIRED_PACKAGES "LEXYACC" )

### Eigen

ecbuild_add_option( FEATURE EIGEN
                    DESCRIPTION "Eigen linear algebra library"
                    REQUIRED_PACKAGES Eigen3 )

set_package_properties( Eigen3 PROPERTIES
                        DESCRIPTION "C++ template library for linear algebra"
                      )

### RADOS

ecbuild_add_option( FEATURE RADOS
                    DEFAULT OFF
                    DESCRIPTION "Ceph/Rados storage support"
                    REQUIRED_PACKAGES Rados )

### Armadillo

ecbuild_add_option( FEATURE ARMADILLO
                    CONDITION HAVE_EXPERIMENTAL
                    DESCRIPTION "Armadillo linear algebra library"
                    REQUIRED_PACKAGES Armadillo )

set_package_properties( Armadillo PROPERTIES
                        DESCRIPTION "C++ linear algebra"
                      )

### MKL

ecbuild_add_option( FEATURE MKL
                    DESCRIPTION "MKL linear algebra library"
                    REQUIRED_PACKAGES MKL )

### Compression

ecbuild_add_option( FEATURE BZIP2
                    DESCRIPTION "BZip2 support for compression"
                    REQUIRED_PACKAGES BZip2 )

ecbuild_add_option( FEATURE SNAPPY
                    DESCRIPTION "Snappy support for compression"
                    REQUIRED_PACKAGES Snappy )

ecbuild_add_option( FEATURE LZ4
                    DESCRIPTION "LZ4 support for compression"
                    REQUIRED_PACKAGES LZ4 )

ecbuild_add_option( FEATURE AEC
                    DESCRIPTION "AEC support for compression"
                    REQUIRED_PACKAGES AEC )

### LAPACK

if( ECKIT_HAVE_MKL )
    set( ECKIT_HAVE_LAPACK 1 )
    set( LAPACK_LIBRARIES ${MKL_LIBRARIES} )
else()
    ecbuild_add_option( FEATURE LAPACK
                        DESCRIPTION "Linear Algebra PACKage"
                        REQUIRED_PACKAGES "LAPACK QUIET" )
endif()

### OpenSSL (for SHA1)

ecbuild_add_option( FEATURE SSL
                    DESCRIPTION "OpenSSL support"
                    REQUIRED_PACKAGES OpenSSL )

if( OPENSSL_FOUND )
  ecbuild_info("OpenSSL version ${OPENSSL_VERSION} -- libs [${OPENSSL_LIBRARIES}] incs [${OPENSSL_INCLUDE_DIR}]")
endif()

### xxHash

ecbuild_add_option( FEATURE XXHASH
                    DESCRIPTION "Use xxHash for non-crypto hashing in data integrity checks"
                    REQUIRED_PACKAGES "xxHash QUIET" )

if( XXHASH_FOUND )
  ecbuild_info("xxHash -- libs [${XXHASH_LIBRARIES}] incs [${XXHASH_INCLUDE_DIRS}]")
endif()

#### Curl

ecbuild_add_option( FEATURE CURL
                    DESCRIPTION "Curl library for transfering data with URLs"
                    REQUIRED_PACKAGES CURL )

#### Jemalloc

ecbuild_add_option( FEATURE JEMALLOC
                    DEFAULT OFF
                    DESCRIPTION "Link against jemalloc memory allocator"
                    REQUIRED_PACKAGES Jemalloc )

#### CUDA

ecbuild_add_option( FEATURE CUDA
                    CONDITION HAVE_EXPERIMENTAL
                    DESCRIPTION "CUDA GPU linear algebra operations"
                    REQUIRED_PACKAGES CUDA )

### ViennaCL

ecbuild_add_option( FEATURE VIENNACL
                    CONDITION HAVE_EXPERIMENTAL
                    DESCRIPTION "ViennaCL OpenCL linear algebra operations"
                    REQUIRED_PACKAGES ViennaCL )

set_package_properties( ViennaCL PROPERTIES
                        DESCRIPTION "linear algebra library for computations on many-core architectures"
                        TYPE RECOMMENDED
                        PURPOSE "Dense and sparse matrix operations on OpenCL devices" )

### Performance tests

ecbuild_add_option( FEATURE EXTRA_TESTS
                    DEFAULT OFF
                    DESCRIPTION "Add additional unit/performance tests" )

### async io support

find_package( AIO )
set_package_properties( AIO PROPERTIES TYPE RECOMMENDED PURPOSE "support for asynchronous IO" )

### c math library, needed when including "math.h"

find_package( CMath )

###############################################################################
# checks

# check thread library is pthreads
if( NOT ${CMAKE_USE_PTHREADS_INIT} )
    message( FATAL_ERROR "Only pthreads supported - thread library found is [${THREADS_LIBRARIES}]" )
endif()

############################################################################################
# export package info

set( ECKIT_INCLUDE_DIRS   ${CMAKE_CURRENT_SOURCE_DIR}/src ${CMAKE_CURRENT_BINARY_DIR}/src )
set( ECKIT_LIBRARIES      eckit eckit_geometry eckit_linalg eckit_maths eckit_web )

if( HAVE_ECKIT_CMD)
  list( APPEND ECKIT_LIBRARIES eckit_cmd )
endif()

if( HAVE_ECKIT_MPI )
  list( APPEND ECKIT_LIBRARIES eckit_mpi )
endif()

if( HAVE_EXPERIMENTAL )

  list( APPEND ECKIT_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/src/experimental )

endif()

get_directory_property( ECKIT_DEFINITIONS COMPILE_DEFINITIONS )

############################################################################################
# sources

ecbuild_find_project_files()

include_directories( ${ECKIT_INCLUDE_DIRS} )
if( HAVE_EIGEN )
    include_directories( ${EIGEN3_INCLUDE_DIR} )
endif()

add_subdirectory( bamboo )
add_subdirectory( doc )
add_subdirectory( src )
add_subdirectory( tests )
add_subdirectory( regressions )

ecbuild_add_resources( TARGET ${PROJECT_NAME}_top_files SOURCES
                       TODO AUTHORS README.md NOTICE LICENSE INSTALL ChangeLog COPYING )

############################################################################################
# finalize

foreach( _lib ${ECKIT_LIBRARIES} )
  if( TARGET ${_lib} )
    ecbuild_pkgconfig( NAME ${_lib}
                       DESCRIPTION "ECMWF C++ Toolkit - ${_lib} library"
                       URL "https://software.ecmwf.int/wiki/display/ECKIT/ecKit"
                       LIBRARIES ${_lib} )
  endif()
endforeach()

ecbuild_install_project( NAME ${PROJECT_NAME} )

ecbuild_print_summary()

=== mars-client/CMakeLists.txt ===
cmake_minimum_required( VERSION 3.1 FATAL_ERROR )

project( mars_client C CXX )

set( CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake")

include( ecbuild_system NO_POLICY_SCOPE )

ecbuild_requires_macro_version( 2.9 )

ecbuild_declare_project()

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

###############################################################################
### dependencies

option( ECMWF "build the client as for ECMWF"  OFF )

### eccodes

ecbuild_use_package( PROJECT eccodes VERSION 0.14 REQUIRED )
set( GRIB_API_INCLUDE_DIRS ${ECCODES_INCLUDE_DIRS} )
set( GRIB_API_LIBRARIES    ${ECCODES_LIBRARIES} )
set( GRIB_API_DEFINITIONS  ${ECCODES_DEFINITIONS} )
set( grib_api_BASE_DIR     ${eccodes_BASE_DIR} )

### eckit

ecbuild_add_option( FEATURE UDP_STATS
    DESCRIPTION "Send statistics over UDP"
    DEFAULT ON
    REQUIRED_PACKAGES "PROJECT eckit  VERSION 1.0" )

if( HAVE_UDP_STATS )
    list( APPEND MARS_FEATURE_LIBRARIES eckit )
endif()

### mir

ecbuild_add_option( FEATURE PPROC_MIR
    DESCRIPTION "compile with MIR interpolation"
    DEFAULT ON
    REQUIRED_PACKAGES "PROJECT mir" )

if( HAVE_PPROC_MIR )
    list( APPEND MARS_FEATURE_LIBRARIES mir )
endif()

### libemos

ecbuild_add_option( FEATURE PPROC_EMOS
    DESCRIPTION "compile with EMOSLIB interpolation"
    DEFAULT ON
    REQUIRED_PACKAGES "PROJECT libemos" )

if( HAVE_PPROC_EMOS )
    list( APPEND MARS_FEATURE_LIBRARIES emos )
endif()


ecbuild_add_option( FEATURE BUFR_TOOLS
    DESCRIPTION "compile BUFR tools"
    DEFAULT ON
    REQUIRED_PACKAGES "PROJECT libemos" )

### odb

ecbuild_add_option( FEATURE ODB
    DESCRIPTION "compile with ODB support"
    DEFAULT ON
    REQUIRED_PACKAGES "PROJECT odb_api  VERSION 0.10 " )

if( HAVE_ODB )
  list( APPEND MARS_FEATURE_LIBRARIES Odb )
endif()


ecbuild_add_option( FEATURE MARS_USER_ENVIRONMENT
    DESCRIPTION "Mars user will be in $MARS_USER"
    DEFAULT OFF
)

### mars-server for ODB direct access

ecbuild_add_option( FEATURE ODBDIRECT
    DESCRIPTION "compile with ODB direct support"
    DEFAULT ${ECMWF}
    REQUIRED_PACKAGES "PROJECT mars_server VERSION 7.12" )

if( HAVE_ODBDIRECT )
  list( APPEND MARS_FEATURE_LIBRARIES Odb Odbsvr )
endif()

ecbuild_add_option( FEATURE FDB
    DEFAULT ${ECMWF}
    DESCRIPTION "support for FDB"
    REQUIRED_PACKAGES "PROJECT fdb VERSION 4.6" )

if( HAVE_FDB )
  list( APPEND MARS_FEATURE_LIBRARIES fdb )
endif()

ecbuild_add_option( FEATURE FDB5
    DEFAULT ${ECMWF}
    DESCRIPTION "support for FDB5"
    REQUIRED_PACKAGES "PROJECT fdb5 VERSION 5.0" )

if( HAVE_FDB5 )
    list( APPEND MARS_FEATURE_LIBRARIES fdb5 )
endif()

### netcdf

ecbuild_add_option( FEATURE NETCDF
    DEFAULT ON
    DESCRIPTION "support for NetCDF"
    REQUIRED_PACKAGES NetCDF )

if( HAVE_NETCDF )
  list( APPEND MARS_FEATURE_LIBRARIES ${NETCDF_LIBRARIES} )
endif()

### others

find_package( CURL )
find_package( CMath )

set( CMAKE_THREAD_PREFER_PTHREAD 1 ) # find thread library, but prefer pthreads
find_package(Threads REQUIRED)

ecbuild_add_option( FEATURE ECMWF_DEVELOPMENT
    DEFAULT OFF
    DESCRIPTION "Special mode for development, activates ECMWF but deactivates auth, ems and schedule" )

###############################################################################
# sanity checks -- these are more pain than helpful to be honest

if(ECMWF)

    if( NOT HAVE_PPROC_MIR OR NOT HAVE_PPROC_EMOS  )
        message( FATAL_ERROR "At ECMWF mars-client requires PPROC (for which MIR or EMOSLIB is required)" )
    endif()

    if( NOT TRANSI_HAVE_FFTW AND NOT ATLAS_HAVE_FFTW )
        message( FATAL_ERROR "At ECMWF FFTW library is required" )
    endif()

    if( NOT HAVE_ODB )
      message( FATAL_ERROR "At ECMWF mars-client requires ODB" )
    endif()

endif()

###############################################################################
### build source code

set( MARS_CLIENT_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/src ${CMAKE_CURRENT_BINARY_DIR}/src )

include_directories( ${MARS_CLIENT_INCLUDE_DIRS} )

add_subdirectory( src )
add_subdirectory( tests )

###############################################################################
### finalize

ecbuild_install_project( NAME mars-client )

ecbuild_print_summary() # prints the summary of the configuration

=== metview/CMakeLists.txt ===
############################################################################################
# cmake options:
#
#       -DCMAKE_BUILD_TYPE=Debug|RelWithDebInfo|Release|Production
#
#       -DCMAKE_MODULE_PATH=/path/to/ecbuild/cmake
#
#       -DCMAKE_C_COMPILER=gcc
#       -DCMAKE_C_COMPILER=g++
#
#       -DCMAKE_PREFIX_PATH=/path/to/jasper:/path/to/any/package/out/of/place
#       -DBUILD_SHARED_LIBS=OFF
#
#  Metview-specific:
#  -DMETVIEW_SITE=ecmwf | other
#  -DMETVIEW_SCRIPT=name-of-generated-startup-script
#  -DMARS_HOME=/path/to/MARS/home  (requires WITH_MARS=ON)
#  -DMAGICS_PATH=/path/to/magics   (requires WITH_PLOTTING=ON)
#  -DEXTRA_TITLE=extra-title-string
#  -DLOG_DIR=/path/to/dir/for/module/log/files
#  -DODB1_USE_SCRIPT_PATH=/path/to/odb1/use/script

cmake_minimum_required( VERSION 3.6.0 FATAL_ERROR )

if(POLICY CMP0025)
  cmake_policy(SET CMP0025 NEW)
endif()

project( metview C CXX )


# All executables and scripts apart from the startup script should go into MV_BIN_DIR.
# Users can override by setting METVIEW_INSTALL_EXE_BIN_DIR.
# It should be relative to the root of the install directory.
if(DEFINED METVIEW_INSTALL_EXE_BIN_DIR)
    set(MV_BIN_DIR ${METVIEW_INSTALL_EXE_BIN_DIR})
else()
    set(MV_BIN_DIR bin/metview_bin)
endif()


set(CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake")
set(CMAKE_INCLUDE_DIRECTORIES_PROJECT_BEFORE OFF)

set(INSTALL_BIN_DIR "${MV_BIN_DIR}" CACHE PATH "Metview installation directory for executable files")

include( ecbuild_system NO_POLICY_SCOPE )

IF(APPLE)
  SET(MACOSX_RPATH 1)
  SET(CMAKE_BUILD_WITH_INSTALL_RPATH FALSE)
  #SET(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/lib")
ENDIF(APPLE)

ecbuild_requires_macro_version( 1.9 )

#ecbuild_add_cxx11_flags()  # Magics 3 requires C++11/14
set (CMAKE_CXX_STANDARD 14)
set (CMAKE_C_STANDARD 99)

###############################################################################
# some options of this project

option( ENABLE_UI             "enable the user interface"                          ON )
option( ENABLE_PLOTTING       "enable the plotting module"                         ON )
option( ENABLE_MARS           "enable MARS access"                                 OFF )
option( ENABLE_ODB            "enable ODB"                                         OFF )
option( ENABLE_USAGE_LOG      "enable usage logging (only at ECMWF)"               OFF )
option( ENABLE_QT_DEBUG       "enable Qt debugging messages"                       OFF )
option( ENABLE_INPE           "enable INPE modules"                                OFF )
option( ENABLE_URL_DOWNLOAD   "enable downloading of files from URLs"              ON )
option( ENABLE_WEATHER_ROOM   "enable Weather Room plot export (only at ECMWF)"    OFF )
option( ENABLE_SHARE_PLOT     "enable sharing of plots (only at ECMWF)"            OFF )
option( ENABLE_SHARE_TO_GLOBE "enable Globe plot export (only at ECMWF)"           OFF )
option( ENABLE_NETWORK_PROXY  "enable network proxy settings for WMS"              OFF )
option( ENABLE_EXPERIMENTAL   "enable experimental modules"                        OFF )
option( ENABLE_CONTRIB        "enable externally contributed modules"              OFF )
option( ENABLE_METVIEW_FORTRAN "enable modules which use Fortran code"             ON )
option( ENABLE_METVIEW_DOCS   "enable building of documentation"                   OFF )
#option( ENABLE_CODE_WEBHELP   "enable inline web help in code editor"              OFF )




###############################################################################


if( ENABLE_METVIEW_FORTRAN )
    ecbuild_enable_fortran( REQUIRED )
    set(HAVE_METVIEW_FORTRAN 1)
endif()


# ensure we can add non-existent dependencies - required for generating icon files
if( ${CMAKE_VERSION} VERSION_GREATER "2.9.9" )
    cmake_policy(SET CMP0046 OLD)
endif()



# if we don't explicitly state that we're at ECMWF, then assume we're not, and use the generic config
if(NOT METVIEW_SITE STREQUAL ecmwf)
    set( SITE_WMO_CODE "255")    # DO WE NEED AN OPTION TO ALLOW INSTALLERS TO SPECIFY THIS?
    set( MV_ENVIRON    "common")
    set( AT_ECMWF "FALSE" )
    ecbuild_info("Building outside ECMWF")
else()
    set( SITE_WMO_CODE "098")
    set( MV_ENVIRON    "ecm_lnx64")
    set( AT_ECMWF "TRUE" )
    add_definitions( -DECMWF )
    ecbuild_info("Building inside ECMWF")
endif()


if(DEFINED EXTRA_CONFIG_PATH)
    ecbuild_info("Will search ${EXTRA_CONFIG_PATH} for additional config files")
endif()



# default startup script name
if(NOT DEFINED METVIEW_SCRIPT )
    set( METVIEW_SCRIPT "metview" )
endif()

set(FULL_STARTUP_SCRIPT_PATH ${CMAKE_BINARY_DIR}/bin/${METVIEW_SCRIPT})

# ensure we don't build shared libraries
set(BUILD_SHARED_LIBS OFF)


# Weather Room plot export (ECMWF only)
if(ENABLE_WEATHER_ROOM)
    if(AT_ECMWF)
        ecbuild_add_extra_search_paths( boost ) # Weather Room export needs Boost
        find_package( Boost 1.49.0 )            # Weather Room export needs Boost
        set(MV_WEATHER_ROOM_BUILT true)
    else()
        ecbuild_error("ENABLE_WEATHER_ROOM only available when building at ECMWF")
    endif()
else()
    set(MV_WEATHER_ROOM_BUILT false)
endif()

# Globe plot export (ECMWF only)
if(ENABLE_SHARE_TO_GLOBE)
    if(NOT AT_ECMWF)
        ecbuild_error("ENABLE_SHARE_TO_GLOBE only available when building at ECMWF")
    endif()
    if(NOT ENABLE_SHARE_PLOT)
        ecbuild_error("ENABLE_SHARE_TO_GLOBE only available when ENABLE_SHARE_PLOT is enabled")
    endif()
endif()

if(ENABLE_INPE)
    set(METVIEW_INPE true)
endif()


# --------------------
# look for MARS client 
# --------------------

ecbuild_use_package( PROJECT mars_client VERSION 6.25.3 REQUIRED)

# check which post-processing libraries it found
list(FIND MARS_CLIENT_FEATURES "PPROC_MIR"  HAVE_PPROC_MIR)
list(FIND MARS_CLIENT_FEATURES "PPROC_EMOS" HAVE_PPROC_EMOS)
if (HAVE_PPROC_MIR EQUAL -1)
    set(HAVE_PPROC_MIR 0)
else()
    set(HAVE_PPROC_MIR 1)
endif()
if (HAVE_PPROC_EMOS EQUAL -1)
    set(HAVE_PPROC_EMOS 0)
else()
    set(HAVE_PPROC_EMOS 1)
endif()


if( NOT HAVE_PPROC_MIR AND NOT HAVE_PPROC_EMOS  )
    message( FATAL_ERROR "MARS client requires PPROC (for which MIR or EMOSLIB is required)" )
endif()


if(HAVE_PPROC_MIR)
    ecbuild_use_package( PROJECT eckit   VERSION 1.0  REQUIRED ) # for DivRot, which uses eckit directly
endif()

# decide which interpolation library to use by default
if(HAVE_PPROC_MIR)
    set(DEFAULT_INTERP_PACKAGE "MIR")
else()
    set(DEFAULT_INTERP_PACKAGE "EMOS")
endif()




# look for curl because it is needed for the Mars Web API client
find_package(CURL)


# local MARS access
if(ENABLE_MARS)
    set( MARS_ACCESS MARS_local )
    set( METVIEW_MARS 1 )
    if(DEFINED MARS_LOCAL_HOME)
        ecbuild_info("MARS_LOCAL_HOME=${MARS_LOCAL_HOME}")
        if(NOT EXISTS ${MARS_LOCAL_HOME})
            ecbuild_critical("MARS_LOCAL_HOME (${MARS_LOCAL_HOME}) does not exist")
        else()
            set(MARS_HOME ${MARS_LOCAL_HOME})
        endif()
    else()
        ecbuild_critical("If setting local MARS access, -DMARS_LOCAL_HOME=/path/to/mars/home must be provided.")
    endif()

    list(FIND MARS_CLIENT_FEATURES "ODB" HAVE_MARS_ODB)
    if (HAVE_MARS_ODB EQUAL -1)
        set(ENABLE_MARS_ODB "OFF")
    else()
        set(ENABLE_MARS_ODB "ON")
    endif()
    

    if(ENABLE_MARS_ODB)
        set(ENABLE_ODB 1)
        set(METVIEW_MARS_ODB 1)
    endif()

    #find_library( FDB  REQUIRED )
    #ecbuild_debug("FDB: ${FDB_LIBRARIES}" )

else()
    if(${CURL_FOUND})
        set( MARS_ACCESS MARS_webapi )
    else()
        set( MARS_ACCESS MARS_none )
        add_definitions(-DNOCURL)
        ecbuild_warn("Could not find the Curl library - disabling Web API Mars")
    endif()
endif()


# Network access (download via URLs)
if(ENABLE_URL_DOWNLOAD)
    if(NOT CURL_FOUND)
        ecbuild_critical("URL_DOWNLOAD was enabled, but the 'curl' development package was not found.")
    endif()
endif()




###############################################################################
# local project requirements

# ecbuild_use_package( PROJECT eckit VERSION 0.3 REQUIRED )



ecbuild_use_package( PROJECT eccodes VERSION 2.14.0 REQUIRED
                     FAILURE_MSG "ecCodes is required in order to build Metview. Note that GRIB_API is no longer supported in Metview" )

set( GRIB_API_INCLUDE_DIRS  ${ECCODES_INCLUDE_DIRS} )
set( GRIB_API_LIBRARIES     ${ECCODES_LIBRARIES} )
set( GRIB_API_DEFINITIONS   ${ECCODES_DEFINITIONS} )
set( GRIB_API_TPL_LIBRARIES ${ECCODES_TPL_LIBRARIES} )
set( grib_api_BASE_DIR      ${eccodes_BASE_DIR} )
add_definitions(-DGRIB_HANDLING_PACKAGE=ecCodes)

if(ENABLE_ODB)
    ecbuild_use_package( PROJECT odb_api  VERSION 0.10.1 ) # requires at least this version
    if( ODB_API_FOUND )

        set( METVIEW_ODB_API_LIBRARIES Odb )
        ecbuild_use_package( PROJECT eckit VERSION 0.6 REQUIRED )
        add_definitions(-DODB_ECKIT)

        set(METVIEW_ODB 1)

        if(ODB_API_PATH)
            set(ODB_API_LIB_DIR ${ODB_API_PATH}/lib)
            set(ODB_API_BIN_DIR ${ODB_API_PATH}/bin)
        endif()

        add_definitions(-DMETVIEW_ODB_NEW -DMETVIEW_ODB)
        set(METVIEW_ODB_API_INCLUDE_DIRS ${ODB_API_INCLUDE_DIRS}
                                         ${ODB_API_INCLUDE_DIRS}/..
                                         ${ODB_API_INCLUDE_DIRS}/../eclib
                                         ${ODB_API_INCLUDE_DIRS}/../eclib/eclib
                                         ${ODB_API_INCLUDE_DIRS}/odblib
                                         ${ECKIT_INCLUDE_DIRS})
    else()
        if(ENABLE_MARS_ODB)
            ecbuild_critical("ENABLE_ODB was set, but ODB not found")
            set(ENABLE_MARS_ODB 0)
            set(METVIEW_MARS_ODB 0)
        endif()
    endif()
    ###list( APPEND METVIEW_TPLS odb_api )


    # ODB-1

    ecbuild_use_package( PROJECT ODB )

    if(ODB_FOUND)
        if(EXISTS ${ODB_PATH}/bin)
            if(EXISTS ${ODB_PATH}/bin/odbsql)
                add_definitions(-DMETVIEW_ODB_OLD)
                set(ENABLE_ODB1 "ON")

                if(ODB1_USE_SCRIPT) # was an ODB-1 use script name passed?
                    set(ODB1_LOAD_ENV "MV_ODB1_USE_SCRIPT=${ODB1_USE_SCRIPT}")
                endif()

                if(ODB1_MODULE) # was an ODB-1 module name passed?
                    set(ODB1_LOAD_ENV "MV_ODB1_MODULE=${ODB1_MODULE}")
                endif()

                if(ODB1_VERSION) # was an ODB-1 module name passed?
                    set(MV_ODB1_VERSION ${ODB1_VERSION})
                else()
                    set(MV_ODB1_VERSION "ANY")
                endif()

            else()
                ecbuild_warn("ODB-1 support is DISABLED - No odbsql script found in ${ODB_PATH}/bin")
            endif()
        else()
            ecbuild_warn("ODB-1 found, but no bin directory in ${ODB_PATH}")
        endif()
    else()
        ecbuild_warn("ODB-1 not found!")
    endif()
endif()


if(ENABLE_PLOTTING)
    ecbuild_use_package( PROJECT magics VERSION 4.1.0)
    if( MAGICS_FOUND )

        set(MAGICS_LIB_DIR "${magics_BASE_DIR}/lib")

        if(ENABLE_UI AND (NOT MAGICS_HAVE_METVIEW))
            ecbuild_critical("Magics must be built with Metview and Qt support!")
        endif()

        if((NOT ENABLE_UI) AND (NOT MAGICS_HAVE_METVIEW_NO_QT))
            ecbuild_critical("No UI: Magics must be built with Metview but no Qt support!")
        endif()

        if(NOT MAGICS_HAVE_NETCDF)
            ecbuild_critical("Magics must be built with netCDF support!")
        endif()

        if(MAGICS_HAVE_ODB)
            add_definitions(-DMETVIEW_ODB_PLOT)
        else()
            if(ENABLE_ODB)
                ecbuild_warn("ODB plotting is disabled, because Magics was built without ODB support! Please, rebuild Magics with ODB support to enable ODB plotting!")  #xxx should be at end
            endif()
        endif()

        if(NOT MAGICS_HAVE_CAIRO)

=== mir/CMakeLists.txt ===
cmake_minimum_required( VERSION 3.1 FATAL_ERROR )

project( mir C CXX )

set( CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake" ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild/cmake")

include( ecbuild_system NO_POLICY_SCOPE )

ecbuild_requires_macro_version( 2.9 )

set( PERSISTENT_NAMESPACE "eckit" CACHE INTERNAL "" ) # needed for generating .b files for persistent support

ecbuild_declare_project()

set(CMAKE_CXX_STANDARD 11)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

###############################################################################
# project

ecbuild_add_option( FEATURE MIR_TOOLS          DEFAULT OFF DESCRIPTION "install mir tools" )
ecbuild_add_option( FEATURE MIR_DOWNLOAD_MASKS DEFAULT ON  DESCRIPTION "download LSM files" )

ecbuild_add_option( FEATURE TEST_ASSERTIONS    DEFAULT ON  DESCRIPTION "test: regressions" )
ecbuild_add_option( FEATURE OMP                DEFAULT ON  DESCRIPTION "support for OpenMP shared memory parallelism" )
ecbuild_add_option( FEATURE MPI                DEFAULT OFF DESCRIPTION "support for MPI distributed parallelism" )
ecbuild_add_option( FEATURE NETCDF             DEFAULT ON  DESCRIPTION "support for NetCDF4" REQUIRED_PACKAGES NetCDF4 )
ecbuild_add_option( FEATURE PNG                DEFAULT OFF DESCRIPTION "support for PNG encoding" REQUIRED_PACKAGES PNG )

ecbuild_use_package( PROJECT eccodes VERSION 2.14  REQUIRED )
ecbuild_use_package( PROJECT eckit   VERSION 1.4.2 REQUIRED )
ecbuild_use_package( PROJECT atlas   VERSION 0.19  REQUIRED )

if(ECCODES_FOUND)
    set(HAVE_ECCODES 1)
endif()

if(ATLAS_FOUND)
    set(HAVE_ATLAS 1)
endif()

if(HAVE_PNG)
    add_definitions(${PNG_DEFINITIONS})
endif()


# OMP/MPI features handling
if( ENABLE_OMP )
  ecbuild_enable_omp()
else()
  ecbuild_enable_ompstubs()
endif()

if( ENABLE_MPI )
  ecbuild_enable_mpi()
  if( NOT MPI_CXX_FOUND )
    set( HAVE_MPI 0 )
  endif()
endif()


###############################################################################
# contents

### export package to other ecbuild packages

set( MIR_INCLUDE_DIRS   ${CMAKE_CURRENT_SOURCE_DIR}/src ${CMAKE_CURRENT_BINARY_DIR}/src )
set( MIR_LIBRARIES      mir )

get_directory_property( COMPILE_DEFINITIONS MIR_DEFINITIONS )

foreach( _tpl ${MIR_TPLS} )
  string( TOUPPER ${_tpl} TPL )
  if( ${TPL}_FOUND )
    list( APPEND MIR_EXTRA_DEFINITIONS   ${${TPL}_DEFINITIONS} ${${TPL}_TPL_DEFINITIONS})
    list( APPEND MIR_EXTRA_INCLUDE_DIRS  ${${TPL}_INCLUDE_DIRS} ${${TPL}_TPL_INCLUDE_DIRS} )
    list( APPEND MIR_EXTRA_LIBRARIES     ${${TPL}_LIBRARIES} ${${TPL}_TPL_LIBRARIES})
  endif()
endforeach()

### include directories

include_directories( ${MIR_INCLUDE_DIRS} ${MIR_EXTRA_INCLUDE_DIRS}  )

add_subdirectory( "src" )
add_subdirectory( "etc" )
add_subdirectory( "share" )
add_subdirectory( "tests" )

### installation

# install( DIRECTORY share DESTINATION ${CMAKE_INSTALL_PREFIX} )

ecbuild_add_resources( TARGET ${PROJECT_NAME}_top_files SOURCES
                       TODO AUTHORS README NOTICE LICENSE INSTALL ChangeLog COPYING
                       DONT_PACK
                       BUGS )

############################################################################################
# packaging and installation

ecbuild_install_project( NAME ${PROJECT_NAME} )

ecbuild_print_summary()

=== atlas/doc/CMakeLists.txt ===
# (C) Copyright 2013 ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

add_subdirectory(user-guide)

list( APPEND DOC_CODE_TARGETS
  atlas_c-hello-world
  atlas_c-global-grids-Structured
  atlas_c-global-grids-Unstructured
  atlas_c-meshes-Structured
  atlas_c-fields
  atlas_c-fields-on-grid
  atlas_c-NodeColumns
  atlas_c-StructuredColumns
)
if( ATLAS_HAVE_FORTRAN )
  list( APPEND DOC_CODE_TARGETS
    atlas_f-hello-world
    atlas_f-global-grids-Structured
    atlas_f-meshes-Structured
    atlas_f-fields
    atlas_f-fields-on-grid
    atlas_f-NodeColumns
  )
endif()

add_custom_target(atlas_doc_code)
add_dependencies (atlas_doc_code
                  ${DOC_CODE_TARGETS} )

add_custom_target(atlas_doc_pdf)
add_dependencies (atlas_doc_pdf
                  atlas-user-guide-pdf )

add_custom_target(atlas_doc_html)
add_dependencies (atlas_doc_html
                  atlas-user-guide-html )

add_custom_target(atlas_doc)
add_dependencies (atlas_doc
                  atlas_doc_code
                  atlas_doc_pdf )

if( PROJECT_NAME STREQUAL CMAKE_PROJECT_NAME )

  add_custom_target(doc)
  add_dependencies(doc atlas_doc)

endif()

=== mars-client/src/CMakeLists.txt ===
### config headers

# if we are not building inside the mars-client-bundle we won't have this defined
if(NOT DEFINED MARSCLIENT_VERSION_STR )
  set(MARSCLIENT_VERSION_STR ${MARS_CLIENT_VERSION_STR})
endif()

configure_file( mars_client_version.h.in  mars_client_version.h )
configure_file( mars_client_version.c.in  mars_client_version.c )

# compile definitions

ecbuild_generate_config_headers()
configure_file( mars_client_config.h.in    mars_client_config.h   )

add_definitions( -DR64 )

if( ECMWF )
    add_definitions( -DECMWF )
endif()

test_big_endian( _BIG_ENDIAN )

if( _BIG_ENDIAN )
	message( STATUS "System is big endian" )
else()
	message( STATUS "System is little endian" )
	add_definitions(-DLITTLE_END)
endif()

if( NOT HAVE_FDB )
    add_definitions(-DNOFDB)
endif()

if( NOT HAVE_FDB5 )
    add_definitions(-DNOFDB5)
endif()

if( NOT HAVE_ODB )
	add_definitions(-DNOODB)
else()
	add_definitions(-DODB_SUPPORT )
	include_directories( ${ODB_API_INCLUDE_DIRS} ${ECKIT_INCLUDE_DIRS} )
endif()

if( HAVE_ODBDIRECT )
  add_definitions(-DODBDIRECT)
  include_directories( ${MARS_SERVER_INCLUDE_DIRS} ${ODB_API_INCLUDE_DIRS} ${ECKIT_INCLUDE_DIRS} )
endif()

if( HAVE_PPROC_EMOS )
    list( APPEND mars_client_src_files pproc_emos.cc )
endif()

if( HAVE_PPROC_MIR )
    list( APPEND mars_client_src_files pproc_mir.cc )
endif()

if( NOT CURL_FOUND )
	add_definitions(-DNOCURL)
endif()

if(HAVE_ECMWF_DEVELOPMENT)
  add_definitions(-DECMWF)
  add_definitions(-DNOEMS)
  add_definitions(-DNOAUTH)
  add_definitions(-DNOSCHEDULE)
endif()

# sources

list( APPEND mars_client_src_files
account.c
archive.c
authenticate.c
base.c
bufr.c
calc.c
certify.c
check.c
control.c
cos.c
ecaccess.c
eccert.c
environ.c
expand.c
extargs.c
externf.c
fdb5base.cc
forwardbase.c
odbdirect.cc
feedtask.c
field.c
filebase.c
files.c
flatfilebase.c
free.c
gribbase.c
grib.c
guess.c
handler.c
hash.c
hidden.c
hypercube.c
ibmblk.c
index.c
langy.c
list.c
lock.c
logfile.c
marsxdr.c
mcs.c
memory.c
dhsbase.c
metadata.c
msbase.c
multibase.c
netbase.c
netcdf.c
hdf5.c
nfdbbase.c
nullbase.c
odbbase.c
options.c
pproc.h
pproc.cc
pproc_none.cc
queue.c
rdb.c
remove.c
request.c
restricted.c
retrieve.c
schedule.c
server.c
service.c
sh2ll.c
statistics.c
stream.c
target.c
tcp.c
time.c
timer.c
tools.c
udp.c
variable.c
version.c
json.c
odb.cc
api.c
apibase.c
wind.c)

if(HAVE_UDP_STATS)
  list(APPEND mars_client_src_files udp_statistics.cc)
endif()

if(HAVE_NETCDF)

  list(APPEND mars_client_src_files
    nctarget.c
    nctypes.c
    ncschema.c
    ncmerge.c
    )

endif()


ecbuild_find_lexyacc()
if(FLEX_FOUND)
    set(_lex ${FLEX_EXECUTABLE})
elseif(LEX_FOUND)
    set(_lex ${LEX_EXECUTABLE})
else()
    ecbuild_critical("Found neither flex nor lex")
endif()

if(YACC_FOUND)
    set(_yacc ${YACC_EXECUTABLE})
elseif(BISON_FOUND)
    set(_yacc ${BISON_EXECUTABLE} -y)
else()
    ecbuild_critical("Found neither yacc nor bison")
endif()


if( DEFINED RPCGEN_PATH )
    find_program( RPCGEN_EXECUTABLE NAMES rpcgen PATHS ${RPCGEN_PATH} PATH_SUFFIXES bin NO_DEFAULT_PATH )
endif()
find_program( RPCGEN_EXECUTABLE NAMES rpcgen )
if( NOT RPCGEN_EXECUTABLE )
  ecbuild_critical("Could not find rpcgen. Please provide RPCGEN_PATH.")
endif()


# targets

configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/rpcmars.x ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.x COPYONLY )

add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.h
    COMMAND ${CMAKE_COMMAND} -E remove ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.h
    COMMAND ${RPCGEN_EXECUTABLE} -h -o ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.h ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.x
    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.x )

add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/marsxdr.c
    COMMAND ${CMAKE_COMMAND} -E remove ${CMAKE_CURRENT_BINARY_DIR}/marsxdr.c
    COMMAND ${RPCGEN_EXECUTABLE} -c -o ${CMAKE_CURRENT_BINARY_DIR}/marsxdr.c ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.x
    DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.x )

add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/langl.c
	COMMAND ${_lex} -l ${CMAKE_CURRENT_SOURCE_DIR}/langl.l\; sed -e s/yy/yy_mars/g < lex.yy.c > ${CMAKE_CURRENT_BINARY_DIR}/langl.c
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/langl.l)

add_custom_command(
    OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/langy.c
	COMMAND ${_yacc} -t ${CMAKE_CURRENT_SOURCE_DIR}/langy.y\; sed -e s/yy/yy_mars/g < y.tab.c > ${CMAKE_CURRENT_BINARY_DIR}/langy.c
    DEPENDS ${CMAKE_CURRENT_SOURCE_DIR}/langy.y)

add_custom_target(marsxdr DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.h ${CMAKE_CURRENT_BINARY_DIR}/marsxdr.c)
add_custom_target(marslex DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/langy.c ${CMAKE_CURRENT_BINARY_DIR}/langl.c)


set( grib_handling_pkg eccodes )

set(MARSC_HEADER_FILES_TO_INSTALL
        api.h
        base.h
        bufr.h
        control.h
        cos.h
        field.h
        globals.h
        grib.h
        hypercube.h
        index.h
        json.h
        lang.h
        mars.h
        nctarget.h
        proto.h
        tools.h
        variable.h
        ${CMAKE_CURRENT_BINARY_DIR}/rpcmars.h
)
ecbuild_add_library(
    TARGET      marsclient
    GENERATED   mars_client_version.c
	SOURCES     ${mars_client_src_files} mars_client_version.c
	DEPENDS     marsxdr marslex
    PRIVATE_INCLUDES
        ${NETCDF_INCLUDE_DIRS}
        ${ECKIT_INCLUDE_DIRS}
        ${MARS_SERVER_INCLUDE_DIRS}
        ${FDB5_INCLUDE_DIRS}
        ${GRIB_API_INCLUDE_DIRS}
        ${MIR_INCLUDE_DIRS}
        ${CURL_INCLUDE_DIRS}
    INSTALL_HEADERS_LIST ${MARSC_HEADER_FILES_TO_INSTALL}
    HEADER_DESTINATION ${INSTALL_INCLUDE_DIR}/marsclient
    DEFINITIONS
        ${GRIB_API_DEFINITIONS}
    LIBS
        ${grib_handling_pkg}
        ${FDB5_LIBRARIES}
        ${MARS_FEATURE_LIBRARIES}
        ${CURL_LIBRARIES}
        ${CMATH_LIBRARIES}
        ${CMAKE_THREAD_LIBS_INIT}
)

set_directory_properties( ADDITIONAL_MAKE_CLEAN_FILES rpcmars.h marsxdr.c langl.c langy.c )

ecbuild_add_executable(
    TARGET    mars.bin
    INCLUDES  ${MIR_INCLUDE_DIRS} ${LIBEMOS_INCLUDE_DIRS} ${GRIB_API_INCLUDE_DIRS}
    SOURCES   mars.c
    LIBS      marsclient
)

ecbuild_add_executable(
    TARGET    test-udp-stats
    INCLUDES  ${GRIB_API_INCLUDE_DIRS}
    SOURCES   test-udp-stats.c
    CONDITION HAVE_UDP_STATS
    LIBS      marsclient
)

add_subdirectory( tools )

=== mars-client/tests/CMakeLists.txt ===
find_program( GRIB_COMPARE grib_compare )
find_program( GRIB_LS      grib_ls )

if( NOT GRIB_COMPARE AND TARGET grib_compare )
    get_target_property( GRIB_COMPARE grib_compare LOCATION )
    get_target_property( GRIB_LS      grib_ls      LOCATION )
endif()

ecbuild_add_test(
    TARGET test_${V}_${T}
    ENABLED OFF
    TYPE SCRIPT
    COMMAND ${CMAKE_CURRENT_SOURCE_DIR}/test_${V}
    ARGS ${CMAKE_CURRENT_SOURCE_DIR}/${V}/${R}
)

if( GRIB_COMPARE )
    message( STATUS "tests will use grib_compare: ${GRIB_COMPARE}" )
else()
    message( WARNING "Could not find grib_compare executable -- turning off ${PROJECT_NAME} tests!\nTo enable them place 'grib_compare' on the PATH and re-run cmake" )
endif()

# define the grib environment

set( grib_handling_pkg eccodes )

set( GRIB_DEFINITION_PATH ${grib_api_BASE_DIR}/share/${grib_handling_pkg}/definitions/ )
set( GRIB_SAMPLES_PATH    ${grib_api_BASE_DIR}/share/${grib_handling_pkg}/samples/ )

set( mars_new_binary ${CMAKE_BINARY_DIR}/bin/mars.bin )

configure_file( run_mars.sh.in ${CMAKE_CURRENT_BINARY_DIR}/run_mars.sh @ONLY )

# mars ems permissions
set( USER $ENV{USER} )
configure_file( ems_cache_prod.in ${CMAKE_CURRENT_BINARY_DIR}/ems_cache_prod @ONLY )

#### TESTS

# To add a test, just add the mars request with a .req extension
# and make sure the target=testdata which automatically gets substituted to testdata.prod and testdata.test

list( APPEND _test_reqs
compute.req
interpolation_wave.req
interpolation_gaussian.req
interpolation_l137.req
interpolation_rgg2ll.req
#interpolation_t1279_gg.req  # Creates very large coefficient file
#interpolation_t1279_sh.req  # Creates very large coefficient file
#interpolation_rotated.req   # Failing in ECMWF bundle with Intel
interpolation_latlon.req
interpolation_sh2ll.req
transform_vod2uv.req
retrieve_oper.req
retrieve_enfo.req
#retrieve_ocean.req  # MIR doesn't support GRIB localDefinitionNumber=4
retrieve_fdb_uv_pl.req
retrieve_fdb_uv_ml.req
# retrieve_ai.req
# retrieve_tigge.req
MARSC-94.req
# MARSC-100.001.req
# MARSC-100.002.req
)

if(HAVE_ODB)
    list( APPEND _test_reqs
        odb_filter_updated.req       # As a result of ODB-159 the default codec has changed from short_real to short_real2
        )
endif()

if(ECCODES_HAVE_JPG OR eccodes_HAVE_JPG)
    list( APPEND _test_reqs MARSC-86.req ) # contains jpeg-encoded data
endif()

foreach( t ${_test_reqs} )
    list( APPEND _test_data ${t}.refdata.mir ${t}.inpdata )
endforeach()

ecbuild_get_test_multidata( TARGET get_configs NAMES mars-client-baseconfigs.tar.gz:b7a2b3d3b159813d0b63dc706cc7ed76 EXTRACT )

ecbuild_get_test_multidata( TARGET get_data NAMES ${_test_data} )

ecbuild_add_resources( TARGET tests_run_mars SOURCES_PACK ${_test_reqs} )

foreach( _req ${_test_reqs} )

    string(REGEX REPLACE "[^A-Za-z0-9]" "_" _tst ${_req})

    ecbuild_add_test(
        TARGET test_${_tst}
        TYPE SCRIPT
        COMMAND ${CMAKE_CURRENT_BINARY_DIR}/run_mars.sh
        ARGS ${CMAKE_CURRENT_SOURCE_DIR}/${_req}
        TEST_DEPENDS get_data get_configs
        ENVIRONMENT
            TESTS_DIR=${CMAKE_CURRENT_BINARY_DIR}
            MARS_HOME=${CMAKE_CURRENT_BINARY_DIR}
            MARS_PPROC_BACKEND=MIR
            MIR_HOME=${CMAKE_CURRENT_BINARY_DIR}
    )

endforeach()

=== metview/scripts/CMakeLists.txt ===

set(scripts
    dump metview-mail mvrun mvrun_c mvrun_lnx
    logrun metview_stat metview_create_user_dir
    metview_patches
    mvusage metview_help set_mars_env
    document_macros.pl mv_grib_dump
    metview_local.${MV_ENVIRON} metview_local2.${MV_ENVIRON}
    MarsTiggeWrapper
    MarsOdbWrapper
    generate_video
    mv_compress mv_mail mv_uniquename
    mv_eccharts.py
    mv_odbsql mv_obstat
    mv_mars_catalog.py
    mv_flextra_prep.mv mv_flextra_prep mv_flextra_run
    mv_flexpart_run mv_flexpart_pp
    mv_met3d_prep.mv
    mv_rttov_run
    mv_scm_run mv_scm_vis.mv
    mv_vapor_prep.mv mv_vapor_gui
    select_mars_config
)

if(AT_ECMWF)
    list(APPEND scripts mv_debug_env.sh metgram.py)
endif()

if(HAVE_PPROC_MIR)
    list(APPEND scripts MarsMirWrapper DivrotMirWrapper)
endif()

if(HAVE_PPROC_EMOS)
    list(APPEND scripts MarsEmosWrapper DivrotEmosWrapper)
endif()


# handle these script files
metview_script_files(SCRIPT_FILES ${scripts})



# remove unnecessary items from a colon-separated list (e.g. /usr/lib64, which can interfere if we use non-default compilers)
function(removeUnwantedCompileItemsFromColonString colonString)
    string (REPLACE ":"  ";"   LOC_AS_LIST "${${colonString}}")
    list(REMOVE_ITEM LOC_AS_LIST "/usr/lib")
    list(REMOVE_ITEM LOC_AS_LIST "/usr/lib64")
    string (REPLACE ";"  ":"   LOC_AS_STRING "${LOC_AS_LIST}")
    set (${colonString} ${LOC_AS_STRING} PARENT_SCOPE)
endfunction()


# remove non-compiler items and unnecessary items from the string
function(removeUnwantedCompileItems compileList)
    set(loc ${${compileList}})
    list(REMOVE_ITEM loc "debug")        
    list(REMOVE_ITEM loc "optimized")
    list(REMOVE_ITEM loc "/usr/lib")
    list(REMOVE_ITEM loc "/usr/lib64")
    list(REMOVE_ITEM loc "-L/usr/lib")
    list(REMOVE_ITEM loc "-L/usr/lib64")
    list(REMOVE_ITEM loc "-Wl,-rpath,/usr/lib")
    list(REMOVE_ITEM loc "-Wl,-rpath,/usr/lib64")

    # items could themselves be lists, e.g. rpath=/usr/lib:/usr/local/lib
    foreach (item ${loc})
        set(item1 ${item})
        removeUnwantedCompileItemsFromColonString(item1)
        list(APPEND final_result ${item1})
    endforeach()

    set (${compileList} ${final_result} PARENT_SCOPE)
endfunction()


function(removeUnwantedCompileItemsFromString compileString)
    # convert from string to list, remove items, then convert back to string
    string (REPLACE " "  ";"   LOC_AS_LIST "${${compileString}}")
    removeUnwantedCompileItems(LOC_AS_LIST)
    string (REPLACE ";"  " "   LOC_AS_STRING "${LOC_AS_LIST}")
    set (${compileString} " ${LOC_AS_STRING}" PARENT_SCOPE) # preserve leading space
endfunction()



##############################################################
#
# generate the 'compile' script for inline C/Fortran in Macro




# for GRIB_API, we *might* get something like
# grib_api;grib_api_f77;grib_api_f90;/usr/lib64/libjasper.so;/usr/lib64/libjpeg.so;/usr/lib64/libm.so
# which is not all that we need to link. So we convert 'grib_api' into '-lgrib_api'
# and for the Fortran libraries.

set(GRIB_API_LIBRARIES_STR " ${GRIB_API_LIBRARIES}") # add a space to the beginning

string (REPLACE ";"         " "           GRIB_API_LIBRARIES_STR    "${GRIB_API_LIBRARIES_STR}")
if( ECCODES_FOUND )
  string (REPLACE " eccodes"  " -leccodes"  GRIB_API_LIBRARIES_STR  "${GRIB_API_LIBRARIES_STR}")
else()
  string (REPLACE " grib_api" " -lgrib_api" GRIB_API_LIBRARIES_STR  "${GRIB_API_LIBRARIES_STR}")
endif()


set(GRIB_API_LIBRARIES_STR "${GRIB_API_LIBRARIES_STR} ${PTHREAD_LIB}") # add pthread in case needed


# we may need to add the netCDF lib dir to the rpath. We don't seem to have a variable
# which tells us this directly, so we need to make an educated guess...
if(DEFINED NETCDF_INCLUDE_DIR)
    set(NETCDF_LIB_RPATH "-Wl,-rpath,${NETCDF_INCLUDE_DIR}/../lib64:${NETCDF_INCLUDE_DIR}/../lib")
    set(GRIB_API_LIBRARIES_STR "${GRIB_API_LIBRARIES_STR} ${NETCDF_LIB_RPATH}")
endif()

set(GRIB_API_LIBRARIES_STR_ORIGINAL "${GRIB_API_LIBRARIES_STR}")       # keep a backup for later


# if we are linking with shared GRIB_API libraries, then in order to be able
# to run compiled inline Fortran/C/Macro programs, we will need to set
# LD_LIBRARY_PATH to where GRIB_API was installed (this should only be
# needed if GRIB_API was installed in a non-default location).

# first, if GRIB_API_PATH is not defined, then we need to compute the path
set( grib_handling_pkg grib_api )
if( ECCODES_FOUND )
  set( grib_handling_pkg eccodes )
endif()
if(NOT GRIB_API_PATH)
    get_property(GRIB_LIB_PATH TARGET ${grib_handling_pkg} PROPERTY LIBRARY_OUTPUT_DIRECTORY)
    if(GRIB_LIB_PATH)
        set(GRIB_API_PATH ${GRIB_LIB_PATH}/..)
    else()
        if (grib_api_BASE_DIR)
            set(GRIB_API_PATH ${grib_api_BASE_DIR})
        else()
            if(CMAKE_PREFIX_PATH)
                set(GRIB_API_PATH ${CMAKE_PREFIX_PATH})
            endif()
        endif()
    endif()
    ecbuild_info("Computed GRIB_PATH: ${GRIB_API_PATH}")
endif()


if(GRIB_API_PATH)
    set(GRIB_API_RPATH "${GRIB_API_PATH}/lib:${GRIB_API_PATH}/lib64")
endif()


# for each of the GRIB library's dependencies, we should find the directory name
# and add it to the -L and to the rpath

foreach (gtpl ${GRIB_API_TPL_LIBRARIES})
    get_filename_component(gtpl_i ${gtpl} PATH)  # DIRECTORY only in CMake > 2.8.12+
    list(APPEND GRIB_LIB_TPL_DIRS ${gtpl_i})
endforeach()

if (GRIB_LIB_TPL_DIRS)
    list(REMOVE_DUPLICATES GRIB_LIB_TPL_DIRS)
    string (REPLACE ";" ":"   GRIB_LIB_TPL_RPATH    "${GRIB_LIB_TPL_DIRS}")
endif()
set(GRIB_API_RPATH "${GRIB_API_RPATH}:${GRIB_LIB_TPL_RPATH}")

set(GRIB_API_LIBRARIES_STR "-L${GRIB_API_PATH}/lib -L${GRIB_API_PATH}/lib64 -Wl,-rpath,${GRIB_API_RPATH} ${GRIB_API_LIBRARIES_STR}")
removeUnwantedCompileItemsFromString(GRIB_API_LIBRARIES_STR)


# add the GRIB include directories to the compiler directives
if(DEFINED GRIB_API_INCLUDE_DIRS)
    # linking with external eccodes
    foreach (inc ${GRIB_API_INCLUDE_DIRS})
        set(GRIB_API_INCLUDE_DIRS_STR "${GRIB_API_INCLUDE_DIRS_STR} -I${inc}")
    endforeach()
else()
    # linking with eccodes in a bundle
    set(GRIB_API_INCLUDE_DIRS_STR "-I${ECCODES_BASE_DIR}/include")
endif()
list(APPEND METVIEW_INLINE_DEFINITIONS ${GRIB_API_DEFINITIONS})

#
# something similar for fdb
#

if(FDB_FOUND)
    if(FDB_LIBRARY)  # fdb in bundle
        get_filename_component(FDB_LIB_DIR ${FDB_LIBRARY} PATH)
        set(FDB_LIBRARIES_STR "${FDB_LIBRARY} -Wl,-rpath,${FDB_LIB_DIR}")
    else()           # fdb not in bundle
        foreach(fdblib ${FDB_LIBRARIES})
            set(FDB_MINUS_L_LIBS " -l${fdblib} ${FDB_MINUS_L_LIBS}")
        endforeach()
        set(FDB_LIBRARIES_STR "")
        set(libdirs lib lib64)
        foreach(libdir ${libdirs})
            set(FDB_LIBRARIES_STR "-Wl,-rpath,${fdb_BASE_DIR}/${libdir} -L${fdb_BASE_DIR}/${libdir} ${FDB_LIBRARIES_STR}")
        endforeach()
        set(FDB_LIBRARIES_STR "${FDB_MINUS_L_LIBS} ${FDB_LIBRARIES_STR}")
    endif()
endif()


# in the case of a static libemos, we may need to be explicit about about the Fortran libraries when
# building inline C
foreach(fortlib ${CMAKE_Fortran_IMPLICIT_LINK_LIBRARIES})
    set(IMPLICIT_FORTRAN_LIBS "-l${fortlib}  ${IMPLICIT_FORTRAN_LIBS}")
endforeach()



configure_file(compile.in ${CMAKE_BINARY_DIR}/bin/compile @ONLY)



# in the case of a bundle, the GRIB_API and emoslib locations will have been
# set to their build directories, which is correct when running from 
# the build directory, but not once installed, so we have to change these
# to the location where they will be installed, and create another 'compile'
# script which is the one that will actually be installed. In the case where
# we're not building a bundle, these two compile scripts will be identical.

# this checks if ECCODES is inside a bundle with us
if(MV_BUNDLE_CONTAINS_ECCODES)
    set(GRIB_API_LIBRARIES_STR    "-L${CMAKE_INSTALL_PREFIX}/lib ${GRIB_API_LIBRARIES_STR_ORIGINAL}")
    set(GRIB_API_INCLUDE_DIRS_STR "-I${CMAKE_INSTALL_PREFIX}/include")
    set(GRIB_API_PATH ${CMAKE_INSTALL_PREFIX})
endif()


# this checks if emoslib is inside a bundle with us
if(MV_BUNDLE_CONTAINS_EMOSLIB)
	string(REPLACE "${CMAKE_BINARY_DIR}/lib"  "${CMAKE_INSTALL_PREFIX}/lib"  EMOS_LIBRARIES_STR  "${EMOS_LIBRARIES_STR}")
endif()


# it would be nice to be a bit neater here, but this aspect is hard-coded in ecCodes
# and the fact that the path for MMFS definitions is in /MEMFS is not accessible
# from CMake, so we need to duplicate that piece of information here

if(ECCODES_HAVE_MEMFS)
    set(GRIB_API_SHARE_DIR "/MEMFS")
else()
    set(GRIB_API_SHARE_DIR "${GRIB_API_PATH}/share/${grib_handling_pkg}")
endif()


if( DEFINED NETCDF_PATH )
    set(NETCDF_BIN "${NETCDF_PATH}/bin")
else()
    set(NETCDF_BIN "")
endif()

if(MV_BUNDLE_CONTAINS_METVIEW)
    set(METVIEW_BUNDLE_SRC ${CMAKE_SOURCE_DIR})
endif()

if(MV_BUNDLE_CONTAINS_MAGICS)
    set(MV_BUNDLE_MAGICS_SRC ${CMAKE_SOURCE_DIR}/magics)
endif()


configure_file(compile.in ${CMAKE_BINARY_DIR}/bin/compile_install @ONLY)



install( FILES ${CMAKE_BINARY_DIR}/bin/compile_install  
         DESTINATION ${MV_BIN_DIR}
         RENAME      compile
         PERMISSIONS OWNER_WRITE OWNER_READ GROUP_READ WORLD_READ OWNER_EXECUTE GROUP_EXECUTE WORLD_EXECUTE)




##################
#
# for metview_base





ecbuild_get_date(TODAYS_DATE)


# # Add certain paths to LD_LIBRARY_PATH.
# # If the given path is not a standard system one, then add it to our list
# # of paths to add to LD_LIBRARY_PATH on Metview's startup. We want to
# # avoid adding system paths here because they can override non-default
# # paths (case in point: the wrong OpenGL library has been known to be
# # picked up - used by VAPOR).
#
# NO - this is not really needed with the rpath, and it can lead, in the
# case of a bundle, to the build directory (Magics) going into the
# LD_LIBRARY_PATH even when installed (no harmful effect seen though).
# 
# set(SYS_LIBDIRS "/usr/lib64" "/usr/lib64/" "/usr/lib" "/usr/lib/" "")
# set(METVIEW_LD_PATHS "")
# 
# foreach(LIBPATH ${MAGICS_LIB_DIR} ${ODB_API_LIB_DIR} ${GRIB_API_LIB_DIR})
#     list(FIND SYS_LIBDIRS ${LIBPATH} IND)
#     if(IND EQUAL -1)  # path not in the list of system paths
#         set(METVIEW_LD_PATHS "${LIBPATH}:${METVIEW_LD_PATHS}")
#     endif()
# endforeach()



# MAGPLUS_HOME - under normal circumstances, we link with a specific
# Magics library which knows where it's been installed, so we don't
# need (or want) to set MAGPLUS_HOME, and in fact we want to avoid
# the situation where a user sets it to the wrong path (as can happen
# if a Magics module is set up by default in a user's environment).
# So the simplest thing is to unset MAGPLUS_HOME and let the library
# find its own resource files. This works fine if Magics has been
# installed, but not if we are linking with a Magics in the build tree.
# In this case MAGPLUS_HOME will need to point to the Magics source(!)
# directory. In Magics 2.27.0 onwards, this is all taken care of by the
# CMake variable MAFPLUS_HOME. If this is not set (i.e. earlier version
# of Magics) then we just unset it. MV_MAGPLUS_HOME_PATH_SET is used
# in metview_base.in.

if(DEFINED MAGPLUS_HOME)
    set(MV_MAGPLUS_HOME_PATH_SET "MAGPLUS_HOME=${MAGPLUS_HOME}")
else()
    set(MV_MAGPLUS_HOME_PATH_SET "unset MAGPLUS_HOME")
endif()

if(DEFINED INSTALL_LIB_DIR) # could be lib or lib64
    set(MV_INSTALL_LIB_DIR ${INSTALL_LIB_DIR})
else()
    set(MV_INSTALL_LIB_DIR "lib")
endif()



# MV_BUNDLE_TOOLS_BIN
# - in particular, where odb_migrator (from odb-tools) is located
if((MV_BUNDLE_CONTAINS_METVIEW) AND (NOT ENABLE_EXPOSE_SUBPACKAGES))
    set(MV_BUNDLE_TOOLS_BIN "$METVIEW_BIN/..")
endif()


# create the Metview startup script
configure_file(metview_base.in ${FULL_STARTUP_SCRIPT_PATH} @ONLY)


# create a 'production' version of this - just the same, but with
# METVIEW_VERSION=prod instead of dev

=== metview/src/CMakeLists.txt ===

#add_subdirectory( libMars )
add_subdirectory( libMvMacroApi )
add_subdirectory( libMetview )
add_subdirectory( libFTimeUtil )

#add_subdirectory( Datacoverage )
add_subdirectory( Divrot )
add_subdirectory( Ecfile )
add_subdirectory( Event )
add_subdirectory( Macro )
add_subdirectory( MvApp )
add_subdirectory( Flextra )
add_subdirectory( GribVectors )
add_subdirectory( Hovmoeller )
add_subdirectory( KML )
add_subdirectory( Met3D )
add_subdirectory( ObsFilter )
add_subdirectory( Percentile )
if (HAVE_METVIEW_FORTRAN)
    add_subdirectory( PottF )
    add_subdirectory( Spectra )
endif()
add_subdirectory( PythonServe )
add_subdirectory( Relhum )
add_subdirectory( Rttov )
add_subdirectory( Scm )
add_subdirectory( Stations )
add_subdirectory( StdAppManager )
add_subdirectory( Thermo )
add_subdirectory( Velstr )
add_subdirectory( Vapor )
add_subdirectory( XSection )

if(ENABLE_INPE)
    add_subdirectory(CptecAccess)
endif()

if(ENABLE_URL_DOWNLOAD)
    add_subdirectory(Download)
endif()

if(ENABLE_UI)
    add_subdirectory(libMvQtUtil)
    add_subdirectory(libMvQtGui)
    #add_subdirectory(libMvQtTextPager)
    add_subdirectory(AppMod)
    add_subdirectory(BufrExaminer)
    add_subdirectory(DebugTools)
    add_subdirectory(Eccharts)
    add_subdirectory(ExamineManager)
    add_subdirectory(FlextraExaminer)
    add_subdirectory(GeopExaminer)
    add_subdirectory(GribExaminer)
    add_subdirectory(MacroEditor)
    add_subdirectory(NcExaminer)
    add_subdirectory(OgcClient)
    add_subdirectory(ScmEditor)
 
    # omitted: VisTools


    if(ENABLE_EXPERIMENTAL)
        add_subdirectory(MarsCatalog)
    endif()

    add_subdirectory(Desktop)
endif()


if(ENABLE_PLOTTING)
    add_subdirectory(uPlot)
    add_subdirectory(MagML)
    add_subdirectory(Reprojection)

    if(AT_ECMWF)
        add_subdirectory(Meteogram)
    endif()
endif()


if(ENABLE_ODB)
    add_subdirectory(Odb)
    if(ENABLE_UI)
        add_subdirectory(OdbExaminer)
    endif()
endif()


# still to do:
#     ensure that contents of images directory are put into tarball

# will not do:  libMars-ecregrid Obstat ObstatCurveTool ObstatScatterTool

# propagate ModuleObjectSpecFiles to the parent scope so we can use it again
set(ModuleObjectSpecFiles ${ModuleObjectSpecFiles} PARENT_SCOPE)
set(ModuleXpmFiles        ${ModuleXpmFiles}        PARENT_SCOPE)
set(ModuleSvgFiles        ${ModuleSvgFiles}        PARENT_SCOPE)

=== mir/etc/CMakeLists.txt ===
add_subdirectory("mir")

=== mir/src/CMakeLists.txt ===
add_subdirectory( mir )

add_subdirectory( tools )

add_subdirectory( sandbox )

=== debian/changelog ===
metview (5.7.5-1) unstable; urgency=medium

  * New upstream release
  * Drop build-deps on  libxxhash-dev, libsnappy-dev, liblz4-dev, libbz2-dev.
    These are now subdeps of libeckit-dev.
  * Build-depend on libeckit-dev and libatlas-ecmwf-dev
  * use-external-atlas.patch to use above lib
  * No longer ship atlas libs or headers
  * Standards-Version: 4.4.1.0
  * d/rules: Drop gzip of example files no longer shipped

 -- Alastair McKinstry <mckinstry@debian.org>  Wed, 15 Jan 2020 12:20:01 +0000

=== debian/control ===
Source: metview
Section: science
Priority: optional
Maintainer: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 12), 
  ecbuild,
  gfortran | fortran-compiler, 
  python3-all-dev,
  flex, 
  bison, 
  clang-tidy,
  libncurses5-dev,
  libpng-dev,
  libssl-dev,
  libhdf5-dev, 
  liblapack-dev,
  libpango1.0-dev, 
  libfftw3-dev,
  libeigen3-dev,
  chrpath, 
  mksh,
  libqt5webkit5-dev (>= 5.212.0~alpha2-15), 
  qtbase5-dev, libqt5xmlpatterns5-dev,
  libeccodes-dev (>= 2.2.0),
  libeccodes-tools,
  libodb-api-dev (>= 0.18.0-5),
  libatlas-ecmwf-dev (>= 0.19.0-3), 
  libatlas-ecmwf-utils,
  libeckit-dev (>= 1.4.7-3),
  libemos-dev (>= 2:4.1.1-2),  libemos-bin,
  libboost-dev, libopenjp2-7-dev,
  libmagics++-metview-dev, 
  libmagics++-dev (>= 4.0.3),
  libxmu-dev, libgdbm-dev, 
  libcurl4-gnutls-dev,
  libcairo2-dev, 
  pkg-config,
  swig, 
  libexpat1-dev,
  libterralib-dev (>= 4.3.0+dfsg.2-8), 
  libproj-dev, libqt5svg5-dev,
  libgd-dev, 
  imagemagick, 
  libnetcdf-dev, libnetcdf-cxx-legacy-dev,
  flextra, 
  flexpart,
  libgeotiff-dev
Standards-Version: 4.4.1.0
Homepage: https://software.ecmwf.int/wiki/display/METV/Metview
Vcs-Browser: https://salsa.debian.org:/science-team/metview.git
Vcs-Git: https://salsa.debian.org:/science-team/metview.git

Package: metview
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}, libmetview0d (=${binary:Version}),
 x11-utils, metview-data, python3
Recommends: magics++, flextra, flexpart
Description: Interactive data visualization and analysis environment,
 Metview has been designed as a flexible, modular and extendible system 
 able to accommodate the evolving needs of the user. 
 The system is based on the ECMWF standards for graphics (Magics) and 
 data access (MARS) but can also access locally stored data. 
 The user interface is based on Motif and Qt. Metview is a 
 fully distributed system where modules can run on different workstations
 and servers.
 .
 Metview is a cooperative project between ECMWF and INPE/CPTEC, Brazil. 
 ECMWF has also been assisted by a staff member of Météo-France. 

Package: metview-data
Depends: ${misc:Depends}
Architecture: all
Multi-Arch: foreign
Description: Data needed for the Metview data analysis environment
 Metview has been designed as a flexible, modular and extendible system
 able to accommodate the evolving needs of the user.
 The system is based on the ECMWF standards for graphics (Magics) and
 data access (MARS) but can also access locally stored data.
 The user interface is based on Motif and Qt. Metview is a
 fully distributed system where modules can run on different workstations
 and servers.
 .
 This package provides data files needed for metvieww.

Package: libmetview0d
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, ${shlibs:Depends}
Section: libs
Description: Shared libraries  for MetView
 Metview has been designed as a flexible, modular and extendible system
 able to accommodate the evolving needs of the user.
 The system is based on the ECMWF standards for graphics (Magics) and
 data access (MARS) but can also access locally stored data.
 The user interface is based on Motif and Qt. Metview is a
 fully distributed system where modules can run on different workstations
 and servers.
 .
 This package provides shared libraries and  for  Metview-based software.

Package: libmetview-dev
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libmetview0d (=${binary:Version}), 
 libodb-api-dev, libxxhash-dev, libsnappy-dev, liblz4-dev, libbz2-dev
Section: libdevel
Description: Development files for MetView
 Metview has been designed as a flexible, modular and extendible system
 able to accommodate the evolving needs of the user.
 The system is based on the ECMWF standards for graphics (Magics) and
 data access (MARS) but can also access locally stored data.
 The user interface is based on Motif and Qt. Metview is a
 fully distributed system where modules can run on different workstations
 and servers.
 .
 This package provides static libraries and include files for building
 Metview-based software.

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1


DPKG_EXPORT_BUILDFLAGS = 1
include /usr/share/dpkg/buildflags.mk
include /usr/share/dpkg/pkg-info.mk

# DEB_LDFLAGS_MAINT_PREPEND:= -Wl,-z,defs -Wl,--as-needed
DEB_BUILD_MAINT_OPTIONS:= hardening=+all,-format
DEB_CFLAGS_MAINT_APPEND:= -Wall -pedantic -fPIC
export DEB_BUILD_MAINT_OPTIONS DEB_CFLAGS_MAINT_APPEND DEB_LDFLAGS_MAINT_PREPEND
export QT_SELECT=5
CXXFLAGS:= $(shell dpkg-buildflags --get CXXFLAGS) -std=gnu++14

# Fixes for 32-bit archss
ARCH_32BIT:=   i386 armel armhf mipsel hppa hurd-i386 m68k powerpc sh4 x32
ifneq ($(filter $(ARCH_32BIT),$(DEB_HOST_ARCH)),)
ENABLE_32BIT:= -DENABLE_32_BIT_HOST=On 
endif

# Needed for sbuild. metview creates temp directories during build
export HOME:=/tmp
export METVIEW_LOCALHOST:=127.0.0.1
export METVIEW_DEBUG:=1

# Test suite requires 4 processors. Fake it
export OMPI_MCA_rmaps_base_oversubscribe=1

# Code should import these from eccodes-import but doesn't
export ECCODES_SAMPLES_PATH=/usr/share/eccodes/samples
export ECCODES_DEFINITION_PATH=/usr/share/eccodes/definitions
export ECCODES_IFS_SAMPLES_PATH=/usr/share/eccodes/ifs_samples

DESTDIR:=$(CURDIR)/debian/tmp/
DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
TARGET_ARCH ?= $(shell dpkg-architecture -qDEB_TARGET_ARCH_CPU)
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
AUTOGENERATED:= libmetview-dev.install  metview.install libmetview0d.install libmetview0d.links
MV_DIR:=/usr/lib/$(DEB_HOST_MULTIARCH)/metview
export METVIEW_DIR_DEV:=$(CURDIR)/debian/build
export METVIEW_BIN:=$(METVIEW_DIR_DEV)/bin


# Hack until complter  uses this directory
FC:=$(shell basename $(shell readlink -f /usr/bin/f95))
FMODDIR:=$(LIBDIR)/fortran/$(FC)
FCFLAGS:=$(shell dpkg-buildflags --get FCFLAGS) -I $(FMODDIR)

LC_ALL=C
TZ=UTC+0
export LC_ALL TZ

FPIC:= ''
ifeq ($(TARGET_ARCH), i386)
	FPIC:= -fPIC
endif

# magic debhelper rule
%:
	dh $@ --buildsystem=cmake --builddirectory=$(METVIEW_DIR_DEV) 

override_dh_auto_clean:
	dh_auto_clean
	rm -f $(patsubst %, debian/%, ${AUTOGENERATED})
	rm -f metview/src/images/metview.png

# magics++ upstream ships with a copy of terralib, which is not used in Debian. 
# Instead we use # a shared terralib library, and so need to include terralib.
# Also -fPIC, for some reason.

override_dh_auto_configure:
	for f in ${AUTOGENERATED} ; do \
                sed -e 's%@ARCH@%${DEB_HOST_MULTIARCH}%g' < debian/$$f.in  > debian/$$f ; \
                done
	dh_auto_configure -- \
		-DCMAKE_MODULE_PATH=/usr/share/ecbuild/cmake \
		-DENABLE_EXPOSE_SUBPACKAGES=On \
		-DODB_PATH=/usr \
		-DENABLE_PPROC_MIR=Off \
		-DENABLE_URL_DOWNLOAD=On \
		-DENABLE_MIR_DOWNLOAD_MASKS=Off \
		-DENABLE_SCM_RTTOV=On \
		-DENABLE_EXPERIMENTAL=Off \
		-DENABLE_CODE_WEBHELP=Off \
		-DENABLE_CONTRIB=On \
		-DCMAKE_CXX_STANDARD=14 \
		-DCMAKE_CXX_STANDARD_REQUIRED=On \
		-DMETVIEW_SITE=debian  \
		-DCMAKE_BUILD_TYPE=Release \
		-DMETVIEW_EXTRA_LIBRARIES='terralib -lemosR64 -leccodes -leckit -leckit_option' \
		-DMETVIEW_EXTRA_INCLUDE_DIRS=/usr/include/terralib/kernel \
		-DMAGICS_HAVE_METVIEW=True \
		-DMAGICS_HAVE_NETCDF=True \
		-DMAGICS_PATH=/usr \
		-DBUILD_SHARED_LIBS=On \
		-DSKIP_INSTALL_RPATHS=On \
		-DENABLE_RPATHS=Off \
		-DENABLE_RELATIVE_RPATHS=Off \
		-DENABLE_ODB=On \
		-Dodb_api_DIR=${LIBDIR}/cmake/odb_api \
		-DFLEXTRA_PATH=/usr/bin/flextra \
		-DDISABLE_OS_CHECK=On \
		-DCMAKE_Fortran_FLAGS=$(FCFLAGS) \
		-DFPIC=${FPIC} \
		-DCMAKE_Fortran_FLAGS='$(FCFLAGS)'  \
		$(ENABLE_32BIT)

	( cd ${METVIEW_DIR_DEV}/share ; tar axpf $(CURDIR)/../metview_$(DEB_VERSION_UPSTREAM).orig-data.tar.xz )
	# These get generated ok on a machine with network connection, but fail on sbuilds, etc.
	# so copy pre-generated versions stored in etc
	mkdir -p debian/build/share/metview/etc/
	cp debian/etc/* debian/build/share/metview/etc/
	# cd debian/build/share/metview/etc && $(MAKE) ObjectListAllTarget
	cp metview/src/images/metview_logo.png metview/src/images/metview.png

override_dh_auto_test:
	echo IGNORING TESTS FOR THE MOMENT
	# ( LD_LIBRARY_PATH=$(CURDIR)/debian/build/lib dh_auto_test  )

override_dh_fixperms-arch:
	dh_fixperms
	rm -f debian/metview/usr/lib/*/metvidew/metview_post_install_tests.sh
	# chmod 755 debian/metview/$(MV_DIR)/mv_compress
	mv debian/metview/$(MV_DIR)/metview_bin/* debian/metview/$(MV_DIR)
	rmdir debian/metview/$(MV_DIR)/metview_bin
	chmod 644 debian/metview/$(MV_DIR)/metview_*.common
	chmod 644 debian/metview/$(MV_DIR)/metview_stat
	chmod 644 debian/metview/$(MV_DIR)/metview_patches
	chmod 644 debian/metview/usr/share/images/metview/*
	file debian/metview/$(MV_DIR)/* | grep ELF | cut -f1 -d: | xargs chrpath -d
	chrpath -d debian/libmetview0d/usr/lib/*/lib*so.*

override_dh_fixperms-indep:
	dh_fixperms
	rm -rf debian/metview-data/usr/share/applications
	find debian/metview-data/usr/share/metview -type f -exec chmod 644 {} \;
	find debian/metview-data/usr/share/metview -type d -exec chmod 755 {} \;
